/******************************************************************************
 * 
 * Copyright (c) 2011 Freescale Semiconductor;
 * All Rights Reserved                       
 *
 *******************************************************************************
 *
 * THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
 * IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 ***************************************************************************//*!
 *
 * @file      d4dlcdhw_px_dcu_fb.h
 *
 * @author    b36968
 * 
 * @version   0.0.2.0
 * 
 * @date      Jul-31-2012
 * 
 * @brief     D4D driver - px_dcu_fb hardware lcd driver source c file 
 *
 ***************************************************************************//*!
 */
#ifndef __D4DLCDHW_PX_DCU_FB_H
#define __D4DLCDHW_PX_DCU_FB_H

#if (D4D_MK_STR(D4D_LLD_LCD_HW) == d4dlcdhw_px_dcu_fb_ID)

/******************************************************************************
 * Includes
 ******************************************************************************/
#include "d4dlcdhw_px_dcu_fb_cfg.h"

/******************************************************************************
 * Constants
 ******************************************************************************/
#ifndef DCU_PCLK 
#error Define input clock of DCU : macro DCU_PCLK
#endif	

#ifndef PCLK_MAX  
#error Define maximal input clock of display : macro PCLK_MAX
#endif	

#ifndef D4DLCDHWFB_START_ADDRESS 
#error Define Frame Buffer Start Adress : macro D4DLCDHWFB_START_ADDRESS
#endif	

#ifndef D4DLCDHWFB_X_MAX 
#define D4DLCDHWFB_X_MAX 320
#endif	

#ifndef D4DLCDHWFB_Y_MAX 
#define D4DLCDHWFB_Y_MAX 240
#endif	

#ifndef D4DLCDHWFB_BPP_BYTE 
#define D4DLCDHWFB_BPP_BYTE 2
#endif	

/******************************************************************************
 * Types
 ******************************************************************************/

/******************************************************************************
 * Macros 
 ******************************************************************************/

/******************************************************************************
 * Global variables
 ******************************************************************************/

/******************************************************************************
 * Global functions
 ******************************************************************************/

#endif
#endif /* __D4DLCDHW_PX_DCU_FB_H */

