/******************************************************************************
* 
* Copyright (c) 2010 Freescale Semiconductor;
* All Rights Reserved                       
*
*******************************************************************************
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
***************************************************************************//*!
*
* @file      d4dlcdhw_k70_lcdc_cfg.h
*
* @author    b01119
* 
* @version   0.0.2.0
* 
* @date      Jun-29-2012
* 
* @brief     D4D driver - k70_lcdc hardware lcd driver configuration header file 
*
*******************************************************************************/

#ifndef __D4DLCDHW_K70_LCDC_CFG_H
#define __D4DLCDHW_K70_LCDC_CFG_H


  /******************************************************************************
  * includes
  ******************************************************************************/
  // include here what the driver need for run for example "derivative.h"
  // #include "derivative.h"    /* include peripheral declarations and more for S08 and CV1 */ 
 // #include "MK70F15.h"
  #include <mqx.h>  
  #include <psp.h>  
  #include <bsp.h>     
  /******************************************************************************
  * Constants
  ******************************************************************************/
//#define FRD43040CA
#define FRD43040ID
//#define FRD300C4006
//#define FRD500A4001
//#define FRD5040TPT
//#define FRD5040TPTB
//#define FRD7040TPT


#define D4D_LLD_LCD_HW_K70LCDC d4dlcdhw_k70_lcdc_sqm4EB
#define SQM4EB_REV_1_0  0

#if defined(FRD5040TPT) || defined(FRD7040TPT) 
	#define D4DLCDHWFB_X_MAX 800
	#define D4DLCDHWFB_Y_MAX 480
#endif

#if defined (FRD500A4001) || defined(FRD5040TPTB) || defined(FRD43040CA) || defined(FRD43040ID)
	#define D4DLCDHWFB_X_MAX 480
	#define D4DLCDHWFB_Y_MAX 272
#endif

  #define D4DLCDHWFB_BPP_BYTE                   4
  #define D4DLCDHWFB_BPP BPP24
  #define D4DLCDHWFB_MIRROWED                   0
  #define D4DLCDHWFB_CACHE_FLUSH_ENABLE         1
  #define D4DLCDHWFB_DOUBLE_BUFFER              1
  #define D4DLCDHWFB_DMA_ENABLE                 1
  #define D4DLCDHWFB_DMA_CHANNEL                6

//#define D4DLCDHWFB_START_ADDRESS 0x70400000

  // define here what you need to be configurable

#endif /* __D4DLCDHW_K70_LCDC_CFG_H */