/**HEADER********************************************************************
* 
* Copyright (c) 2012 Freescale Semiconductor;
* All Rights Reserved                       
*
*
*************************************************************************** 
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
**************************************************************************
*
* $FileName: file_list.h$
* $Version : 3.6.1.0$
* $Date    : Aug-14-2012$
*
* Comments:
*
*   This file contains the header information for the eGUI example file browser.
*
*END************************************************************************/


#ifndef __FILE_LIST_H
#define __FILE_LIST_H

/******************************************************************************
* Includes
******************************************************************************/


/******************************************************************************
* Constants
******************************************************************************/

#ifndef PATHNAME_SIZE
  #define PATHNAME_SIZE 260
#endif

//#ifndef FILELIST_FILESYSTEM_HANDLE
//  #define FILELIST_FILESYSTEM_HANDLE filesystem_handle
//#endif

/******************************************************************************
* Macros 
******************************************************************************/

/******************************************************************************
* Types
******************************************************************************/

typedef char FILENAME[14];

typedef struct {
  MQX_FILE_PTR  mfs_fd;
  LWord fileCount;
  LWord dirCount;
  FILENAME * pFileNames;
  FILENAME * pDirNames;
  FILENAME fileMask;
  char pCurrPath[PATHNAME_SIZE];
  
}FILE_LIST;

/******************************************************************************
* Global variables
******************************************************************************/
//extern MQX_FILE_PTR FILELIST_FILESYSTEM_HANDLE;

/******************************************************************************
* Global functions
******************************************************************************/
FILE_LIST* FileList_Install(MQX_FILE_PTR pMFS_FD, char* pStartPath);
void FileList_UnInstall(FILE_LIST* pFileList);

void FileList_RefreshData(FILE_LIST* pFileList);
void FileList_ChangeDirectory(FILE_LIST* pFileList, LWord ix);
void FileList_SetCurrentPath(FILE_LIST* pFileList, char* pNewPath);

char* FileList_GetCurrentPath(FILE_LIST* pFileList);
LWord FileList_GetDirCnt(FILE_LIST* pFileList);
LWord FileList_GetFilesCnt(FILE_LIST* pFileList);
char* FileList_GetFileName(FILE_LIST* pFileList, LWord ix);
char* FileList_GetDirName(FILE_LIST* pFileList, LWord ix);



#endif    // __FILE_LIST_H

