/***************************************************************************//*!
*
* @file      format.c
*
* @author    
* 
* @version   
* 
* @date      
* 
* @brief     Format RAM disk 
*
******************************************************************************/


#include "format.h"
#include <mfs.h>
#include <shell.h>
#include <mqx.h>

/** Creates an MFS virtual drive in RAM memory, occupying area from [base] to
*   [base+size].
* @param[out] fd_ptr  Address to store filesystem descriptor to.
* @param[in]  base    Base address of the drive in RAM.
* @param[in]  size    Number of bytes to allocate for the drive.
* @param[in]  drive   Drive identifier, e.g. "c:". Must contain the colon!
* @param[in]  device  Device identifier, e.g. "mfs_ramdisk_c:". Must contain
*                     the semicolon!
* @param[in]  label   Up to 8 characters labeling the disk, e.g. "MY_RAM_C".
* @return             TRUE on success, FALSE on failure. */
boolean RAM_disk_format(MQX_FILE_PTR *fd_ptr, pointer base, _file_size size, char *drive, char *device, char *label) {
  MQX_FILE_PTR dev_handle1;
  int_32 error_code;
  _mqx_uint mqx_status;
  char *strings[]={drive,drive,label};
  
/*  static boolean format = FALSE;
  
  if(format) {
    return TRUE;
  }
  
  format=TRUE;*/
  
  mqx_status = _io_mem_install(device, base, size);   //Instalace ovladacu pameti
  /* Number of sectors is returned by ioctl IO_IOCTL_GET_NUM_SECTORS function */
  /* If another disc structure is desired, use MFS_FORMAT_DATA structure to   */
  /* define it and call standart format function instead default_format       */   
  if ( mqx_status != MQX_OK ) {
    //_task_block();
    return FALSE;
  }
  
  dev_handle1 = fopen(device, 0);      //Otevre RAM pamet jako device pro MFS
  if ( dev_handle1 == NULL ) {
    return FALSE;
    //_task_block();
  }
  
  mqx_status = _io_mfs_install(dev_handle1, drive, (_file_size)0);      // Instalace  MFS
  if (mqx_status != MFS_NO_ERROR) 
  {
    //_task_block();
    return FALSE;
  } else 
  {
    printf("\nRam Disk '%s' : %u B (0x%X - 0x%X)\n", drive, (unsigned long)size, (unsigned long)base, (unsigned long)base+(unsigned long)size);
  }
  
  (*fd_ptr) = fopen(drive, NULL);        //Otevre disk a kontrola zformatovani
  error_code    = ferror(*fd_ptr);
  if ((error_code != MFS_NO_ERROR) && (error_code != MFS_NOT_A_DOS_DISK))
  {
    return FALSE;
    //_task_block();
  }
  if ( error_code == MFS_NOT_A_DOS_DISK ) 
  {
    printf("\nFormat disk!");
    Shell_format(3, strings );
  }
  
  return TRUE;
}