/******************************************************************************
* 
* Copyright (c) 2012 Elnico s.r.o.
* All Rights Reserved                       
*
*******************************************************************************
*
* THIS SOFTWARE IS PROVIDED BY ELNICO "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL ELNICO OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
****************************************************************************//*!
*
* @file      d4d_icon_button.h
*
* @author    Petr Kubiznak
* 
* @version   1.0
* 
* @date      Sep-03-2012
* 
* @brief     D4D IconButton - an interactive button
*
******************************************************************************/


/****************************************************************************
*       Includes header files
****************************************************************************/
#include "d4d.h"


typedef struct {
    D4D_ICON *pIcon;
    void (*OnClick)(D4D_OBJECT_PTR pThis);
} D4D_ICON_BUTTON;

/******************************************************************************
* Macros 
******************************************************************************/

/*********************************************************
*
* static declaration macros
*
*********************************************************/

#define D4D_DECLARE_BUTTON_ICON_BEGIN(name, text, x, y, cx, cy, tx, ty, flags, pScheme, fontId, pUser, pOnValch, pOnUsrMsg) \
    D4D_DECLARE_ICON_BEGIN(name, text, x, y, cx, cy, 0, 0, (D4D_ICON_F_DEFAULT), NULL, font, pUser, pOnValch, pOnUsrMsg)

#define D4D_DECLARE_STD_ICON_BUTTON(name, text, x, y, cx, cy, pBmpNormal, pBmpActive, font, onclick) \
    D4D_DECLARE_ICON_BEGIN(name, text, x, y, cx, cy, tx, ty, (D4D_ICON_F_DEFAULT), NULL, font, NULL, NULL, NULL)\
    D4D_DECLARE_ICON_BMP((pBmpNormal))\
    D4D_DECLARE_ICON_BMP((pBmpActive))\
    D4D_DECLARE_ICON_END()
