/******************************************************************************
* 
* Copyright (c) 2012 Freescale Semiconductor;
* All Rights Reserved                       
*
*******************************************************************************
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
***************************************************************************//*!
*
* @file      d4d_screen_openfile.h
*
* @author    b01119
* 
* @version   0.0.1.0
* 
* @date      Aug-14-2012
* 
* @brief     D4D driver - filelist of d4d typical screen source file
*
******************************************************************************/

#ifndef _D4D_SCREEN_FILELIST_H
  #define _D4D_SCREEN_FILELIST_H

/******************************************************************************
* Includes
******************************************************************************/
#include "file_list.h"

/******************************************************************************
* Constants
******************************************************************************/
#define FILE_DIALOG_FILENAME_SIZE 14
/******************************************************************************
* Macros 
******************************************************************************/

/******************************************************************************
* Types
******************************************************************************/
typedef enum
{
  FD_OK,
  FD_CANCEL  
}FILE_DIALOG_RESULT;

typedef struct FILE_DIALOG_S
{
  FILE_LIST* pFileList;
  LWord dirCnt;
  LWord fileCnt;
  D4D_LIST_BOX_ITEM*  pItemsFiles;
  D4D_LIST_BOX_ITEM*  pItemsDirectories; 
  D4D_CHAR pOutputPath[PATHNAME_SIZE];
  void (*FileDialogEnds)(struct FILE_DIALOG_S* pThis, FILE_DIALOG_RESULT result);  
}FILE_DIALOG;
/******************************************************************************
* Global variables
******************************************************************************/

/******************************************************************************
* Global functions
******************************************************************************/
FILE_DIALOG* D4D_FileDialogCreate(D4D_CHAR* pStartPath, void (*pFileDialogEndsFunc)(FILE_DIALOG* pThis, FILE_DIALOG_RESULT result));
void D4D_FileDialogShow(FILE_DIALOG* pFileDialog);
void D4D_FileDialogDestroy(FILE_DIALOG* pFileDialog);
D4D_BOOL D4D_FileDialogUpdate(void);
D4D_CHAR* D4D_FileDialogGetDirName(FILE_DIALOG* pFileDialog);
D4D_CHAR* D4D_FileDialogGetFileName(FILE_DIALOG* pFileDialog);
#endif


