/******************************************************************************
* 
* Copyright (c) 2012 Elnico s.r.o.
* All Rights Reserved                       
*
*******************************************************************************
*
* THIS SOFTWARE IS PROVIDED BY ELNICO "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL ELNICO OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
****************************************************************************//*!
*
* @file      schemes.c
*
* @author    Petr Kubiznak
* 
* @version   1.0
* 
* @date      Sep-15-2012
* 
* @brief     Common color schemes.
*
******************************************************************************/

#include "schemes.h"

/******************************************************************************/
D4D_DECLARE_CLR_SCHEME_INRAM(schemeWhiteOnBlack, \
        D4D_COLOR_BLACK, D4D_COLOR_BLACK, D4D_COLOR_BLACK, D4D_COLOR_WHITE, D4D_COLOR_WHITE, D4D_COLOR_BLACK,\
        D4D_COLOR_BLACK, D4D_COLOR_GREY, D4D_COLOR_BRIGHT_GREY, D4D_COLOR_LIGHT_GREY,\
        D4D_COLOR_WHITE, D4D_COLOR_WHITE, D4D_COLOR_WHITE, D4D_COLOR_WHITE,\
        D4D_COLOR_WHITE, D4D_COLOR_WHITE,\
        D4D_COLOR_BLACK, D4D_COLOR_WHITE, D4D_COLOR_WHITE, D4D_COLOR_WHITE,\
        D4D_COLOR_BLACK,\
        D4D_COLOR_WHITE,\
        D4D_COLOR_BLACK, D4D_COLOR_WHITE, D4D_COLOR_WHITE\
)


/******************************************************************************/
D4D_DECLARE_CLR_SCHEME_INRAM(schemeTransparent, \
        D4D_COLOR_TRANSPARENT, D4D_COLOR_SCR_OUTLINE, D4D_COLOR_SCR_TITLEBAR, D4D_COLOR_SCR_TILTLETEXT, D4D_COLOR_SCR_EXIT_BTN_FORE, D4D_COLOR_TRANSPARENT,\
        D4D_COLOR_TRANSPARENT, D4D_COLOR_TRANSPARENT, D4D_COLOR_TRANSPARENT, D4D_COLOR_TRANSPARENT,\
        D4D_COLOR_FORE_NORM, D4D_COLOR_FORE_DISABLED, D4D_COLOR_FORE_FOCUS, D4D_COLOR_FORE_CAPTURE,\
        D4D_COLOR_GAUG_HUB, D4D_COLOR_GAUG_POINTER,\
        D4D_COLOR_TRANSPARENT, D4D_COLOR_SLDR_BAR_FORE, D4D_COLOR_SLDR_BAR_START, D4D_COLOR_SLDR_BAR_END,\
        D4D_COLOR_TRANSPARENT,\
        D4D_COLOR_GRAPH_GRID,\
        D4D_COLOR_TRANSPARENT, D4D_COLOR_PRGRS_BAR_BAR_FORE, D4D_COLOR_PRGRS_BAR_BAR_END\
)


/******************************************************************************/
#define MY_COLOR_FINE_GREEN             D4D_COLOR_RGB(229, 255, 229)
#define MY_COLOR_FINE1_GREEN            D4D_COLOR_RGB(173, 255, 173)
#define MY_COLOR_FINE2_GREEN            D4D_COLOR_RGB(229, 255, 241)

#define MY_COLOR_DARK_GREEN             D4D_COLOR_RGB(75, 140, 75)

D4D_DECLARE_CLR_SCHEME_INRAM(d4d_clr_scheme_green, \
        MY_COLOR_FINE_GREEN, D4D_COLOR_BLACK, MY_COLOR_DARK_GREEN, D4D_COLOR_WHITE, MY_COLOR_DARK_GREEN, MY_COLOR_FINE_GREEN,\
        MY_COLOR_FINE1_GREEN, MY_COLOR_FINE2_GREEN, MY_COLOR_FINE_GREEN, D4D_COLOR_WHITE,\
        MY_COLOR_DARK_GREEN, D4D_COLOR_GREY, D4D_COLOR_BLACK, D4D_COLOR_GREEN,\
        D4D_COLOR_WHITE, MY_COLOR_DARK_GREEN,\
        D4D_COLOR_SLDR_BAR_BCKG, D4D_COLOR_SLDR_BAR_FORE, D4D_COLOR_SLDR_BAR_START, D4D_COLOR_SLDR_BAR_END,\
        MY_COLOR_FINE_GREEN,\
        D4D_COLOR_GRAPH_GRID,\
        D4D_COLOR_PRGRS_BAR_BAR_BCKG, D4D_COLOR_PRGRS_BAR_BAR_FORE, D4D_COLOR_PRGRS_BAR_BAR_END\
        )

/******************************************************************************/
#define MY_COLOR_BLUE                   D4D_COLOR_RGB(73, 170, 255) 
#define MY_COLOR_FINE_BLUE              D4D_COLOR_RGB(224, 240, 255) 
#define MY_COLOR_FINE1_BLUE             D4D_COLOR_RGB(100, 255, 255) 
#define MY_COLOR_FINE2_BLUE             D4D_COLOR_RGB(200, 255, 255) 


D4D_DECLARE_CLR_SCHEME_INRAM(d4d_clr_scheme_blue, \
        MY_COLOR_BLUE, D4D_COLOR_WHITE, MY_COLOR_FINE_BLUE, D4D_COLOR_BLACK, MY_COLOR_FINE_BLUE, MY_COLOR_BLUE,\
        MY_COLOR_FINE1_BLUE, MY_COLOR_FINE2_BLUE, MY_COLOR_FINE2_BLUE, D4D_COLOR_BLUE,\
        D4D_COLOR_DARK_BLUE, D4D_COLOR_BRIGHT_BLUE, D4D_COLOR_DARK_BLUE, D4D_COLOR_WHITE,\
        D4D_COLOR_GAUG_HUB, D4D_COLOR_GAUG_POINTER,\
        D4D_COLOR_SLDR_BAR_BCKG, D4D_COLOR_SLDR_BAR_FORE, D4D_COLOR_SLDR_BAR_START, D4D_COLOR_SLDR_BAR_END,\
        D4D_COLOR_DARK_BLUE,\
        D4D_COLOR_GRAPH_GRID,\
        D4D_COLOR_PRGRS_BAR_BAR_BCKG, D4D_COLOR_PRGRS_BAR_BAR_FORE, D4D_COLOR_PRGRS_BAR_BAR_END\
        )


/******************************************************************************/
#define MY_COLOR_BLUE_LIGHT             D4D_COLOR_RGB( 73, 170, 255)
#define MY_COLOR_NAVY                   D4D_COLOR_RGB(  0,   0, 100)
#define MY_COLOR_CYAN_LIGHT             D4D_COLOR_RGB(136, 255, 255) 
#define MY_COLOR_GREY_LIGHT             D4D_COLOR_RGB(200, 200, 200)
#define MY_COLOR_GREY_DARK              D4D_COLOR_RGB( 70,  70,  70)


/*#define D4D_DECLARE_CLR_SCHEME(name, \
        scrDesktop, scrOutline, scrTitleBar, scrTitleText, scrExitBtnFore, scrExitBtnBckg,\
        objBckg, objBckgDis, objBckgFocus, objBckgCapture,\
        objFore, objForeDis, objForeFocus, objForeCapture,\
        gaugHub, gaugPointer,\
        sldrBarBckg, sldrBar, sldrBarStart, sldrBarEnd,\
        iconBckg,\
        graphGrid,\
        prgrsBarBarBckg, prgrsBarBar, prgrsBarBarEnd\
        )*/
D4D_DECLARE_CLR_SCHEME_INRAM(d4d_clr_scheme_navy, \
        MY_COLOR_BLUE_LIGHT, MY_COLOR_NAVY, MY_COLOR_NAVY, D4D_COLOR_WHITE, MY_COLOR_NAVY, D4D_COLOR_WHITE,\
        D4D_COLOR_WHITE, MY_COLOR_GREY_LIGHT, MY_COLOR_NAVY, MY_COLOR_CYAN_LIGHT,\
        MY_COLOR_NAVY, MY_COLOR_GREY_DARK, D4D_COLOR_WHITE, MY_COLOR_NAVY,\
        D4D_COLOR_GAUG_HUB, D4D_COLOR_GAUG_POINTER,\
        D4D_COLOR_SLDR_BAR_BCKG, D4D_COLOR_SLDR_BAR_FORE, D4D_COLOR_SLDR_BAR_START, D4D_COLOR_SLDR_BAR_END,\
        MY_COLOR_NAVY,\
        D4D_COLOR_GRAPH_GRID,\
        MY_COLOR_CYAN_LIGHT, MY_COLOR_NAVY, MY_COLOR_NAVY\
        )


/******************************************************************************/
#define MY_COLOR_DARK_RED               D4D_COLOR_RGB(122, 39, 18) 
#define MY_COLOR_RED                    D4D_COLOR_RGB(255, 81, 38)
#define MY_COLOR_RED1                   D4D_COLOR_RGB(255, 106, 0)
#define MY_COLOR_FINE_RED               D4D_COLOR_RGB(255, 178, 127)
#define MY_COLOR_FINE_RED1              D4D_COLOR_RGB(255, 235, 221)

D4D_DECLARE_CLR_SCHEME_INRAM(d4d_clr_scheme_red, \
        MY_COLOR_DARK_RED, D4D_COLOR_WHITE, MY_COLOR_RED, D4D_COLOR_WHITE, MY_COLOR_RED, D4D_COLOR_WHITE,\
        MY_COLOR_RED1, MY_COLOR_FINE_RED, MY_COLOR_RED, MY_COLOR_DARK_RED,\
        MY_COLOR_FINE_RED, MY_COLOR_FINE_RED1, MY_COLOR_FINE_RED, MY_COLOR_FINE_RED,\
        D4D_COLOR_GAUG_HUB, D4D_COLOR_GAUG_POINTER,\
        D4D_COLOR_SLDR_BAR_BCKG, D4D_COLOR_SLDR_BAR_FORE, D4D_COLOR_SLDR_BAR_START, D4D_COLOR_SLDR_BAR_END,\
        MY_COLOR_DARK_RED,\
        D4D_COLOR_GRAPH_GRID,\
        D4D_COLOR_PRGRS_BAR_BAR_BCKG, D4D_COLOR_PRGRS_BAR_BAR_FORE, D4D_COLOR_PRGRS_BAR_BAR_END\
        )

