#ifndef __STRINGS_H
#define __STRINGS_H

/******************************************************************************
* Includes
******************************************************************************/

/******************************************************************************
* Constants
******************************************************************************/
#define STRINGS_PREFIX '@'

#define STRING_LANG_ENG 0
#define STRING_LANG_CZE 1
#define STRING_LANG_CHN 2




#define STR_OPEN                "00"
#define STR_OPENFILE            "01"
#define STR_CLOSE               "02"
#define STR_CANCEL              "03"
#define STR_OK                  "04"
#define STR_QUIT                "05"
#define STR_DIRECTORIES         "06"
#define STR_FILES               "07"
#define STR_DISK                "08"

#define STR_LANG                "09"
#define STR_LANGEN              "10"
#define STR_LANGCZ              "11"
#define STR_LANGCHI             "12"
#define STR_LANGRES1            "13"
#define STR_LANGRES2            "14"
#define STR_LANGRES3            "15"
#define STR_LANGRES4            "16"

#define STR_SETTINGS            "17"
#define STR_SCHEME              "18"
#define STR_SCHEME_GREY         "19"
#define STR_SCHEME_GREEN        "20"
#define STR_SCHEME_BLUE         "21"
#define STR_SCHEME_RED          "22"
#define STR_FONTS               "23"
#define STR_FONTS_COURIER       "24"
#define STR_FONTS_ARIAL         "25"
#define STR_SCRSVR              "26"
#define STR_ENABLE              "27"
#define STR_DUMMY_LABEL         "28"
#define STR_COULD_NOT_SHOW      "29"
#define STR_IMAGE_INFO          "30"
#define STR_TYPE                "31"        
#define STR_WIDTH               "32"
#define STR_HEIGHT              "33"
#define STR_SIZE                "34"
#define STR_TEXT_INFO           "35"
#define STR_ASCII               "36"
#define STR_UNICODE             "37"
#define STR_INFO                "38"

#define STR_FILEBROWSER         "39"

#define STR_VIEW                "40"
#define STR_COPY                "41"
#define STR_REMOVE              "42"
#define STR_EXIT                "43"
#define STR_LEFT                "44"
#define STR_RIGHT               "45"

#define STR_RTCS_INFO           "46"
#define STR_MAC                 "47"
#define STR_IP                  "48"
#define STR_MASK                "49"
#define STR_GATEWAY             "50"

#define STR_UNKNOWN             "99"


/******************************************************************************
* Macros 
******************************************************************************/
#define DEF_EXTSTR(ix) D4D_DEFSTR("@") D4D_DEFSTR(ix)

#define STRINGS_GET_COUNT(x) (sizeof(x) / sizeof(D4D_TCHAR*))

/******************************************************************************
* Types
******************************************************************************/

typedef struct
{
  LWord         index;
  D4D_TCHAR**   langTable;
}STRINGS_LANG_TABLE;

/******************************************************************************
* Global variables
******************************************************************************/

/******************************************************************************
* Global functions
******************************************************************************/
void Strings_ChangeLanguage(LWord ix);

#endif