/************************************************************************
*
*  Freescale INC.
*  ALL RIGHTS RESERVED
*  (c) Copyright 2008 Freescale, Inc.
*
*************************************************************************
*
*  FILE NAME: font.c
*
*  PURPOSE: Fonts used in project.
*
*  AUTHOR: B01119
*
***********************************************************************/
#include "d4d.h"   
#include "unicode_test.h"

const Byte d4dfnt_Tahoma_Page_0_data_table[] = { 

/* character 0x0020 (' '): (width = 4, offset = 0) */
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

/* character 0x0045 ('E'): (width = 7, offset = 8) */
0x00, 0x00, 0x00, 0x0F, 0xD0, 0x20, 0x40, 0xFD, 0x02, 0x04, 0x0F, 0xC0, 0x00, 0x00, 

/* character 0x0047 ('G'): (width = 8, offset = 22) */
0x00, 0x00, 0x00, 0x00, 0x3C, 0x42, 0x80, 0x80, 0x80, 0x8E, 0x82, 0x42, 0x3E, 0x00, 0x00, 0x00,


/* character 0x0049 ('I'): (width = 4, offset = 38) */
0x00, 0x00, 0xE4, 0x44, 0x44, 0x44, 0xE0, 0x00, 

/* character 0x0055 ('U'): (width = 8, offset = 46) */
0x00, 0x00, 0x00, 0x00, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x44, 0x38, 0x00, 0x00, 0x00


};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_0_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0,    /*   ' '        0020       */
            8,    /*   'E'        0045       */
           22,    /*   'G'        0047       */
           38,    /*   'I'        0049       */
           46    /*   'U'        0055       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_0_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
          ' ',    /*   0020          32            0       */
          'E',    /*   0045          69            1       */
          'G',    /*   0047          71            2       */
          'I',    /*   0049          73            3       */
          'U'    /*   0055          85            4       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_0_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
           4,    /*   ' '        0020       */
           7,    /*   'E'        0045       */
           8,    /*   'G'        0047       */
           4,    /*   'I'        0049       */
           8     /*   'U'        0055       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_78_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_0_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    ' ',     // start char of used table
    5,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {8, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_0_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_0_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_0_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_0_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_78_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_78_data_table[] = { 

/* character 0x4E2D (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x04, 0x00, 0x08, 0x03, 0xFF, 0x84, 0x21, 0x08, 0x42, 0x10, 0x84, 0x21, 0x08, 0x7F,
0xF0, 0x04, 0x00, 0x08, 0x00, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 

/* character 0x4E86 (' '): (width = 15, offset = 30) */
0x00, 0x00, 0x00, 0x01, 0xFF, 0x80, 0x02, 0x00, 0x08, 0x00, 0x20, 0x00, 0x80, 0x01, 0x00, 0x02,
0x00, 0x04, 0x00, 0x08, 0x00, 0x10, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_78_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0,    /*   ' '        4E2D       */
           30    /*   ' '        4E86       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_78_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0x4E2D,     /*   4E2D        20013            0       */
         0x4E86     /*   4E86        20102            1       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_78_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15,     /*   ' '        4E2D       */
          15     /*   ' '        4E86       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_84_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_78_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0x4E2D,     // start char of used table
    2,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_78_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_78_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_78_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_78_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_84_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_84_data_table[] = { 

/* character 0x54C7 (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x01, 0x00, 0x02, 0x07, 0x9F, 0x89, 0x08, 0x12, 0x10, 0x25, 0xFE, 0x48, 0x00, 0x90,
0x81, 0x21, 0x03, 0xDF, 0xC0, 0x04, 0x00, 0x08, 0x01, 0xFF, 0x00, 0x00, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_84_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0    /*   ' '        54C7       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_84_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0x54C7     /*   54C7        21703            0       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_84_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15     /*   ' '        54C7       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_89_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_84_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0x54C7,     // start char of used table
    1,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_84_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_84_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_84_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_84_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_89_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_89_data_table[] = { 

/* character 0x59CB (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x41, 0x00, 0x82, 0x07, 0xC9, 0x04, 0x91, 0x09, 0x4E, 0x13, 0xE2, 0x44, 0x00, 0x93,
0xF1, 0xA4, 0x20, 0x88, 0x41, 0x90, 0x84, 0xA1, 0x10, 0x7E, 0x00, 0x00, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_89_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0    /*   ' '        59CB       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_89_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0x59CB     /*   59CB        22987            0       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_89_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15     /*   ' '        59CB       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_91_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_89_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0x59CB,     // start char of used table
    1,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_89_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_89_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_89_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_89_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_91_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_91_data_table[] = { 

/* character 0x5B57 (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x04, 0x03, 0xFF, 0xE4, 0x00, 0x49, 0xFC, 0x80, 0x10, 0x00, 0x40, 0x01, 0x00, 0xFF,
0xF8, 0x04, 0x00, 0x08, 0x00, 0x10, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_91_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0    /*   ' '        5B57       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_91_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0x5B57     /*   5B57        23383            0       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_91_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15     /*   ' '        5B57       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_94_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_91_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0x5B57,     // start char of used table
    1,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_91_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_91_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_91_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_91_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_94_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_94_data_table[] = { 

/* character 0x5E93 (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x00, 0x00, 0x08, 0x02, 0x08, 0x43, 0xEF, 0x04, 0x60, 0x0F, 0xFE, 0x22, 0x40, 0x49,
0x00, 0x92, 0x61, 0x1F, 0x02, 0x08, 0x45, 0xFF, 0x08, 0x20, 0x20, 0x40, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_94_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0    /*   ' '        5E93       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_94_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0x5E93     /*   5E93        24211            0       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_94_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15     /*   ' '        5E93       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_95_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_94_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0x5E93,     // start char of used table
    1,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_94_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_94_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_94_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_94_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_95_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_95_data_table[] = { 

/* character 0x5F00 (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x80, 0x44, 0x00, 0x88, 0x01, 0x10, 0x3F, 0xFC, 0x04,
0x40, 0x08, 0x80, 0x11, 0x00, 0x42, 0x01, 0x84, 0x0C, 0x08, 0x00, 0x00, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_95_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0    /*   ' '        5F00       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_95_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0x5F00     /*   5F00        24320            0       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_95_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15     /*   ' '        5F00       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_99_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_95_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0x5F00,     // start char of used table
    1,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_95_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_95_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_95_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_95_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_99_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_99_data_table[] = { 

/* character 0x6301 (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x41, 0x00, 0x9F, 0xC1, 0x04, 0x0F, 0x08, 0x05, 0xFF, 0x08, 0x08, 0x18, 0x10, 0xEF,
0xF8, 0x40, 0x40, 0x88, 0x81, 0x09, 0x02, 0x02, 0x0C, 0x0C, 0x00, 0x00, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_99_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0    /*   ' '        6301       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_99_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0x6301     /*   6301        25345            0       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_99_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15     /*   ' '        6301       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_101_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_99_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0x6301,     // start char of used table
    1,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_99_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_99_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_99_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_99_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_101_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_101_data_table[] = { 

/* character 0x652F (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x04, 0x00, 0x08, 0x07, 0xFF, 0xC0, 0x20, 0x00, 0x40, 0x0F, 0xF8, 0x08, 0x10, 0x08,
0x40, 0x09, 0x00, 0x0C, 0x00, 0x64, 0x03, 0x06, 0x18, 0x03, 0x00, 0x00, 0x00, 0x00, 

/* character 0x6587 (' '): (width = 15, offset = 30) */
0x00, 0x00, 0x04, 0x00, 0x08, 0x07, 0xFF, 0xC1, 0x04, 0x02, 0x08, 0x02, 0x20, 0x04, 0x40, 0x05,
0x00, 0x04, 0x00, 0x14, 0x00, 0x44, 0x03, 0x06, 0x18, 0x03, 0x00, 0x00, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_101_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0,    /*   ' '        652F       */
           30    /*   ' '        6587       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_101_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0x652F,     /*   652F        25903            0       */
         0x6587     /*   6587        25991            1       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_101_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15,     /*   ' '        652F       */
          15     /*   ' '        6587       */
};

extern const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_255_desc;

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_101_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0x652F,     // start char of used table
    2,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_101_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_101_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_101_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_101_data_table,      // bitmap/font data array
    &d4dfnt_Tahoma_Page_255_desc       // pointer for next UNICODE page
};

const Byte d4dfnt_Tahoma_Page_255_data_table[] = { 

/* character 0xFF01 (' '): (width = 15, offset = 0) */
0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 0x80, 0x01, 0x00, 0x02,
0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

/* character 0xFF0C (' '): (width = 10, offset = 30) */
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x01, 0x80, 0x20,
0x10, 0x00, 0x00, 0x00

};

const D4D_FONT_OFFSET d4dfnt_Tahoma_Page_255_offset_table[] = { 

/*       offset       char      hexcode     */
/*       ======      =====      =======     */
            0,    /*   ' '        FF01       */
           30    /*   ' '        FF0C       */
};

const D4D_FONT_IX d4dfnt_Tahoma_Page_255_index_table[] = { 

/*        char      hexacode      decimal       index     */
/*       ======     ========      =======      =======    */
         0xFF01,     /*   FF01        65281            0       */
         0xFF0C     /*   FF0C        65292            1       */
};

const D4D_FONT_SIZE d4dfnt_Tahoma_Page_255_width_table[] = { 

/*       width        char      hexcode     */
/*       ======      =====      =======     */
          15,     /*   ' '        FF01       */
          10     /*   ' '        FF0C       */
};

const D4D_FONT_DESCRIPTOR d4dfnt_Tahoma_Page_255_desc = {
    0,       // Font descriptor version number
    D4D_FONT_FLAGS_IX_STYLE_NONLINEAR | D4D_FONT_FLAGS_IX_TYPE_MAP | D4D_FONT_FLAGS_FNT_WIDTH_PROPORTIONAL,   // linear / nonlinear , proporcional or not
    0xFF01,     // start char of used table
    2,   // count of all chars of used table
    0x0020,     // index of char that will be printed instead of
    10,       // font size (size of font loaded in PC)
    0,     // height of font bitmpap for non proporcional fonts
    13,      // offset from Y0 coordination to baseline
    {15, 16},     // size of biggest char x/y
    D4D_FONT_PACK_BITORDER_BIGEND | D4D_FONT_PACK_SCANBASED_ROW | D4D_FONT_PACK_SCANPREFERRED_ROW | D4D_FONT_PACK_COMPRESSED_ON,     // packing condition of individual bitmaps
    d4dfnt_Tahoma_Page_255_index_table,          // Index table - is used when nonlinearIX is set in flags, flags also determine the type of IxTable
    d4dfnt_Tahoma_Page_255_offset_table,     // Offset table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_255_width_table,        // Size table - used when proporcial font is set in flags
    d4dfnt_Tahoma_Page_255_data_table,      // bitmap/font data array
    NULL       // pointer for next UNICODE page
};

