#ifndef __main_h_
#define __main_h_


#include "d4d.h"
#include "gui/fonts.h"
#include "string.h"
#include "lwcfg.h"
//#include "pictures.h"


#define  SCREENSAVER_TIMEOUT_100MS      300 // sets to 30s    

#define D4D_MEMPOOL_BASE                0x70000000
#define D4D_MEMPOOL_SIZE                0x04000000

extern _lwmem_pool_id d4dMemoryPoolId;
typedef union
{
 uint_32 all;     
 struct
 {
   unsigned b25ms :1;
   unsigned b50ms : 1;
   unsigned b100ms : 1;
   unsigned b200ms : 1;
   unsigned b400ms : 1;
   unsigned b800ms : 1;
   unsigned b1600ms : 1;    
   unsigned b3200ms : 1;
 }bits;     
}TIME_FLAGS;

extern TIME_FLAGS time;
extern LWord time100sm_cnt;
extern LWord screenSaverTimeoutPreset;
extern D4D_BOOL screenSaverEnabled;

/** Invokes the screen calibration and saves it to the config file.
* @param[in]  pCfgFile  Pointer to an intialized config file structure.
*                       If NULL, TS calibrates, the result just is not written
*                       to any config file. */
void main_calibrateTouchscreen(LWCFG_FILE_PTR pCfgFile);

#endif /* __main_h_ */
