/**HEADER********************************************************************
* 
* Copyright (c) 2008 Freescale Semiconductor;
* All Rights Reserved
*
* Copyright (c) 1989-2008 ARC International;
* All Rights Reserved
*
*************************************************************************** 
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
**************************************************************************
*
* $FileName: Tasks.c$
* $Version : 3.6.8.0$
* $Date    : Jun-3-2010$
*
* Comments:
*
*   
*
*END************************************************************************/


#include "MFS_USB.h"


#if ! BSPCFG_ENABLE_IO_SUBSYSTEM
#error This application requires BSPCFG_ENABLE_IO_SUBSYSTEM defined non-zero in user_config.h. Please recompile BSP with this option.
#endif


#ifndef BSP_DEFAULT_IO_CHANNEL_DEFINED
#error This application requires BSP_DEFAULT_IO_CHANNEL to be not NULL. Please set corresponding BSPCFG_ENABLE_TTYx to non-zero in user_config.h and recompile BSP with this option.
#endif

extern void OpenFile(uint_32 temp)
{
  boolean done=FALSE;
  MQX_FILE_PTR         fs_ptr;
  char_ptr             path_ptr, mode_ptr;
  pointer              dir_ptr;
  char_ptr             buffer;
  int_32               error;
  
  while(!done)
  {
    buffer = NULL;
    error = 0;
    path_ptr  ="*.*";
    mode_ptr = "m";
    
    fs_ptr=_io_get_fs_by_name("c:");
    /* check if filesystem is mounted */ 
    if (fs_ptr == NULL)  {
      printf("Error, file system not mounted\n");
    } else  {
      done=TRUE;
      buffer = _mem_alloc(50);
      
      if (buffer && !error) {
        
        dir_ptr = _io_mfs_dir_open(fs_ptr, path_ptr, mode_ptr ); //important
        
        if (dir_ptr == NULL)  {
          printf("File not found.\n");
        } else {
          printf("\n");
          while ((_io_is_fs_valid(fs_ptr)) && (/*len = */_io_mfs_dir_read(dir_ptr, buffer, 50)) > 0) {
            printf(buffer);
          } 
          _io_mfs_dir_close(dir_ptr);
        }
        _mem_free(buffer);
      } else {
        if(buffer == NULL){
          printf("Error, unable to allocate space.\n" );
        } else {
          printf("Error, directory does not exist.\n" );
        }
      }
    }
    _time_delay(500);
  }
}
/* EOF */
